var table;

function scroll_to_row(tbsel, tdsel, ix)
{
	var h = tdsel.outerHeight();
	var bs = tbsel.css("border-spacing").replace(/\w*\s/,"").replace("px","");
	var bsnum = Number(bs);
	if (Number.isInteger(bsnum))
		h += bsnum;
	
	tbsel.scrollTop(h * ix);
	tdsel.parent().addClass("tabScrollHighlight");
}

function scroll_control_update(ctrlsel)
{
	var tabid = ctrlsel.data('tableid');
	var tsel = $('#'+tabid);
	if ( !tsel.length )
	{
		console.log('WTScrollController - table selector not found');
		return;
	}
	if ( !tsel.hasClass('WTScrollable') )
	{
		console.log('WTScrollController - selected table missing WTScrollable class');
		return;
	}
	var tbsel = tsel.children('tbody');
	if ( !tbsel.length )
	{
		console.log('WTScrollController - table body selector not found');
		return;
	}
	
	tbsel.children("tr").removeClass("tabScrollHighlight");

	var s1 = ctrlsel.val();
	var slen = s1.length;
	if (!slen)
		return;

	if ((tabid == 'available_tab') || (tabid == 'ingroup_tab'))
	{
		// Reporting Group
		// example <td> text: "Agent Smith (2026)"
		var s2 = "("+s1;
		
		tbsel.find('td').each(function(ix, e) {
			var t = $(this).text();
			if (t.substr(0,slen).toLowerCase() == s1.toLowerCase())
			{
				scroll_to_row(tbsel, $(this), ix);
				return false;
			}
			else if (t.indexOf(s2) >= 0)
			{
				scroll_to_row(tbsel, $(this), ix);
				return false;
			}
			
			return true;
		});
	}
	else if ((tabid == "queue_tab") || (tabid == "agent_tab") || (tabid == "user_tab") || (tabid == "qdept_tab"))
	{
		// Queues - if search string is a number, search number column. Otherwise search name column.
		var sn = Number(s1);
		var f;
		if (Number.isInteger(sn))
			f = "td:nth-child(2)";
		else
			f = "td:nth-child(1)";

		tbsel.find(f).each(function(ix, e) {
			var t = $(this).text();
			if (t.substr(0,slen).toLowerCase() == s1.toLowerCase())
			{
				scroll_to_row(tbsel, $(this), ix);
				return false;
			}
			
			return true;
		});
	}
	else if (tabid == "manager_tab")
	{
		// Managers - match on email or name
		tbsel.find('tr').each(function(ix, e) {
			var first_td = $(this).children().first();
			var t1 = first_td.text();
			var t2 = first_td.next().text();
			if ((t1.substr(0,slen).toLowerCase() == s1.toLowerCase()) || (t2.substr(0,slen).toLowerCase() == s1.toLowerCase()))
			{
				scroll_to_row(tbsel, first_td, ix);
				return false;
			}
			
			return true;
		});
	}
}

/* When tbody has been set to display:block to allow scrolling, the browser layout 
   no longer maintains the same widths for thead columns and the associated tbody column.
   Do this programatically. Note that the required widths are sometimes obtained from the
   thead column and sometimes from the tbody column (depending which is wider).
   
   see https://stackoverflow.com/questions/17067294/html-table-with-100-width-with-vertical-scroll-inside-tbody/17380697#17380697

   This function works, but is slow for a long table. Just use fixed column widths.
   
function set_column_widths(tabsel)
{

	var headCells = tabsel.find('thead tr:first').children();
	var bodyCells = tabsel.find('tbody tr:first').children();
	var i;
	for (i=0; i<headCells.length; i++)
	{
		var hw = $(headCells[i]).width();
		var bw = $(bodyCells[i]).width();
		if (hw > bw)
		{
			var j=i+1;
			tabsel.find('tbody td:nth-child('+j+')').width(hw);
		}
		else if (bw > hw)
		{
			$(headCells[i]).width(bw);
		}
	}
}
*/

$(document).ready(function() {

	$('.WTScrollController').keydown(function (event) {
		setTimeout(scroll_control_update, 0, $(this));
	});
	
	/*
	table = $('.WTScrollable');
	setTimeout(set_column_widths, 0, table);
	*/
});

